#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node12.html#SECTION00120 */

void preKmp(char *x, int m, int kmpNext[]) {
  int i, j;

  i = 0;
  j = kmpNext[0] = -1;
  while (i < m) {
    while (j > -1 && x[i] != x[j])
      j = kmpNext[j];
    i++;
    j++;
    if (x[i] == x[j])
      kmpNext[i] = kmpNext[j];
    else
      kmpNext[i] = j;
  }
}

void AXAMAC(char *x, int m, char *y, int n) {
  int i, j, k, ell, kmpNext[XSIZE];

  /* Preprocessing */
  preKmp(x, m, kmpNext);
  for (ell = 1; x[ell - 1] == x[ell]; ell++);
  if (ell == m)
    ell = 0;

  /* Searching */
  i = ell;
  j = k = 0;
  while (j <= n - m) {
    /* while (i < m && x[i] == y[i + j]) */
    while (i < m && x[i] == trace_get(y, i + j))
      ++i;
    if (i >= m) {
      /* while (k < ell && x[k] == y[j + k]) */
      while (k < ell && x[k] == trace_get(y, j + k))
        ++k;
      if (k >= ell)
        OUTPUT(j);
    }
    j += (i - kmpNext[i]);
    if (i == ell)
      k = MAX(0, k - 1);
    else
      if (kmpNext[i] <= ell) {
        k = MAX(0, kmpNext[i]);
        i = ell;
      }
      else {
        k = ell;
        i = kmpNext[i];
      }
  }
}

List apostolico_crochemore(char* pattern, int pattern_size, 
                           char* text, int text_size) {
  return string_matcher_array(AXAMAC, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(AXAMAC, argc, argv);
}
