#include "utils.h"
#include "graph.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node4.html#SECTION0040 */

void preAut(char *x, int m, Graph aut) {
  int i, state, target, oldTarget;
 
  for (state = getInitial(aut), i = 0; i < m; ++i) {
    oldTarget = getTarget(aut, state, x[i]);
    target = newVertex(aut);
    setTarget(aut, state, x[i], target);
    copyVertex(aut, target, oldTarget);
    state = target;
  }
  setTerminal(aut, state);
}
 
 
void AUT(char *x, int m, char *y, int n) {
  int j, state;
  Graph aut;
  
  /* Preprocessing */
  aut = newAutomaton(m + 1, (m + 1)*ASIZE);
  preAut(x, m, aut);
  
  /* Searching */
  for (state = getInitial(aut), j = 0; j < n; ++j) {
    /* state = getTarget(aut, state, y[j]); */
    state = getTarget(aut, state, trace_get(y, j));
    if (isTerminal(aut, state))
      OUTPUT(j - m + 1);
  }
}

List automaton(char* pattern, int pattern_size, 
               char* text, int text_size) {
  return string_matcher_array(AUT, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(AUT, argc, argv);
}
