#include "utils.h"
#include <stdio.h>

/* http://igm.univ-mlv.fr/~lecroq/string/node14.html#SECTION00140 */

void preBmBc(char *x, int m, int bmBc[]) {
  int i;
 
  for (i = 0; i < ASIZE; ++i)
    bmBc[i] = m;
  for (i = 0; i < m - 1; ++i)
    bmBc[x[i]] = m - i - 1;
}
 
 
void suffixes(char *x, int m, int *suff) {
  int f, g, i;
 
  suff[m - 1] = m;
  g = m - 1;
  for (i = m - 2; i >= 0; --i) {
    if (i > g && suff[i + m - 1 - f] < i - g)
      suff[i] = suff[i + m - 1 - f];
    else {
      if (i < g)
        g = i;
      f = i;
      while (g >= 0 && x[g] == x[g + m - 1 - f])
        --g;
      suff[i] = f - g;
    }
  }
}
 
void preBmGs(char *x, int m, int bmGs[]) {
  int i, j, suff[XSIZE];
 
  suffixes(x, m, suff);
 
  for (i = 0; i < m; ++i)
    bmGs[i] = m;
  j = 0;
  for (i = m - 1; i >= 0; --i)
    if (suff[i] == i + 1)
      for (; j < m - 1 - i; ++j)
        if (bmGs[j] == m)
          bmGs[j] = m - 1 - i;
  for (i = 0; i <= m - 2; ++i)
    bmGs[m - 1 - suff[i]] = m - 1 - i;
} 
 
void BM(char *x, int m, char *y, int n) {
  int i, j, bmGs[XSIZE], bmBc[ASIZE];
  int c;

  /* Preprocessing */
  preBmGs(x, m, bmGs);
  preBmBc(x, m, bmBc);

  /* Searching */
  j = 0;
  while (j <= n - m) {
    /* for (i = m - 1; i >= 0 && x[i] == y[i + j]; --i); */
    for (i = m - 1; i >= 0 && x[i] == trace_get(y, i + j); --i);
    if (i < 0)
      OUTPUT(j);
    /* j += MAX(bmGs[i], bmBc[y[i + j]] - m + 1 + i); */
    j += MAX(bmGs[i], bmBc[y[i + j]] - m + 1 + i);
  }
}

List boyer_moore(char* pattern, int pattern_size, 
                 char* text, int text_size) {
  return string_matcher_array(BM, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(BM, argc, argv);
}
