#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node18.html#SECTION00180 */

void preBmBc(char *x, int m, int bmBc[]) {
  int i;
 
  for (i = 0; i < ASIZE; ++i)
    bmBc[i] = m;
  for (i = 0; i < m - 1; ++i)
    bmBc[x[i]] = m - i - 1;
}

void HORSPOOL(char *x, int m, char *y, int n) {
  int j, bmBc[ASIZE];
  char c;

  /* Preprocessing */
  preBmBc(x, m, bmBc);

  /* Searching */
  j = 0;
  while (j <= n - m) {
    /* c = y[j + m - 1]; */
    c = trace_get(y, j + m - 1);
    /* if (x[m - 1] == c && memcmp(x, y + j, m - 1) == 0) */
    if (x[m - 1] == c && trace_memcmp(x, y + j, m - 1, j) == 0)
      OUTPUT(j);
    j += bmBc[c];
  }
}

List horspool(char* pattern, int pattern_size, 
              char* text, int text_size) {
  return string_matcher_array(HORSPOOL, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(HORSPOOL, argc, argv);
}
