#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node5.html#SECTION0050 */

#define REHASH(a, b, h) ((((h) - (a)*d) << 1) + (b))

void KR(char *x, int m, char *y, int n) {
  int d, hx, hy, i, j;

  /* Preprocessing */
  /* computes d = 2^(m-1) with
     the left-shift operator */
  for (d = i = 1; i < m; ++i)
    d = (d<<1);

  for (hy = hx = i = 0; i < m; ++i) {
    hx = ((hx<<1) + x[i]);
    hy = ((hy<<1) + trace_get(y, i));
    /* hy = ((hy<<1) + y[i]); */
  }

  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j <= n-m) {
    start_pruning_duplicates();

    if (hx == hy && trace_memcmp(x, y + j, m, j) == 0)
      OUTPUT(j);
    hy = REHASH(trace_get(y, j), trace_get(y, j + m), hy);
    ++j;

    stop_pruning_duplicates();

    /* if (hx == hy && memcmp(x, y + j, m) == 0) */
    /*   OUTPUT(j); */
    /* hy = REHASH(y[j], y[j + m], hy); */
    /* ++j; */
  }

}

List karp_rabin(char* pattern, int pattern_size, 
                char* text, int text_size) {
  return string_matcher_array(KR, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(KR, argc, argv);
}
