#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node7.html#SECTION0070 */

void preMp(char *x, int m, int mpNext[]) {
  int i, j;

  i = 0;
  j = mpNext[0] = -1;
  while (i < m) {
    while (j > -1 && x[i] != x[j])
      j = mpNext[j];
    mpNext[++i] = ++j;
  }
}

void MP(char *x, int m, char *y, int n) {
  int i, j, mpNext[XSIZE];

  /* Preprocessing */
  preMp(x, m, mpNext);

  /* Searching */
  i = j = 0;
  set_txt_length(n);
  while (j < n) {
    /* while (i > -1 && x[i] != y[j]) */
    while (i > -1 && x[i] != trace_get(y,j))
      i = mpNext[i];
    i++;
    j++;
    if (i >= m) {
      OUTPUT(j - i);
      i = mpNext[i];
    }
  }
} 

List morris_pratt(char* pattern, int pattern_size, 
                  char* text, int text_size) {
  return string_matcher_array(MP, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(MP, argc, argv);
}
