#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node19.html#SECTION00190 */

void preQsBc(char *x, int m, int qsBc[]) {
  int i;

  for (i = 0; i < ASIZE; ++i)
    qsBc[i] = m + 1;
  for (i = 0; i < m; ++i)
    qsBc[x[i]] = m - i;
}


void QS(char *x, int m, char *y, int n) {
  int j, qsBc[ASIZE];

  /* Preprocessing */
  preQsBc(x, m, qsBc);
 
  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j <= n - m) {
    start_pruning_duplicates();
    /* if (memcmp(x, y + j, m) == 0) */
    if (trace_memcmp(x, y + j, m, j) == 0)
      OUTPUT(j);
    j += qsBc[trace_get(y, j + m)];               /* shift */
    stop_pruning_duplicates();
  }
}

List quick_search(char* pattern, int pattern_size, 
                  char* text, int text_size) {
  return string_matcher_array(QS, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(QS, argc, argv);
}
