#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node22.html#SECTION00220 */

void preBmBc(char *x, int m, int bmBc[]) {
  int i;
 
  for (i = 0; i < ASIZE; ++i)
    bmBc[i] = m;
  for (i = 0; i < m - 1; ++i)
    bmBc[x[i]] = m - i - 1;
}

void RAITA(char *x, int m, char *y, int n) {
  int j, bmBc[ASIZE];
  char c, firstCh, *secondCh, middleCh, lastCh;

  /* Preprocessing */
  preBmBc(x, m, bmBc);
  firstCh = x[0];
  secondCh = x + 1;
  middleCh = x[m/2];
  lastCh = x[m - 1];

  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j <= n - m) {
    start_pruning_duplicates();
    c = trace_get(y, j + m - 1);
    if (lastCh == c && 
        firstCh == trace_get(y, j) &&
        middleCh == trace_get(y, j + m/2) &&
        trace_memcmp(secondCh, y + j + 1, m - 2, j + 1) == 0)
      OUTPUT(j);
    j += bmBc[c];
    stop_pruning_duplicates();

    /* c = y[j + m - 1]; */
    /* if (lastCh == c && middleCh == y[j + m/2] && */
    /*     firstCh == y[j] && */
    /*     memcmp(secondCh, y + j + 1, m - 2) == 0) */
    /*   OUTPUT(j); */
    /* j += bmBc[c]; */
  }
}

List raita(char* pattern, int pattern_size, 
           char* text, int text_size) {
  return string_matcher_array(RAITA, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(RAITA, argc, argv);
}
