#include "utils.h"

void rohde05_kmp_(char *pattern, int m, char *text, int n) {
  int i, k, j, f[XSIZE];
  
  i = 0;
  j = f[0] = -1;
  while (i < m - 1) {
    while (j > -1 && pattern[i] != pattern[j]) {
      j = f[j];
    }
    i++;
    j++;
    if (pattern[i] == pattern[j]) {
      f[i] = f[j];
    } else {
      f[i] = j;
    }
  }

  i = k = 0;
  while (i < m && k < n) {
    while (i > -1 && pattern[i] != trace_get(text, k)) {
      i = f[i];
    }
    i++;
    k++;
  }
  return;
  /* if (i == m) */
  /*   return k - i; */
  /* else */
  /*   return -1; */
}

List rohde05_kmp(char* pattern, int pattern_size, 
                char* text, int text_size) {
  return string_matcher_array(rohde05_kmp_, 
                              pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(rohde05_kmp_, argc, argv);
}
