#include <stdlib.h>
#include <string.h>
#include "utils.h"
#include "linkedlist.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node31.html#SECTION00310 */

void SKIP(char *x, int m, char *y, int n) {
  int i, j;
  List ptr, z[ASIZE];

  /* Preprocessing */
  memset(z, NULL, ASIZE*sizeof(List));
  for (i = 0; i < m; ++i) {
    ptr = (List)malloc(sizeof(struct _cell));
    if (ptr == NULL)
      error("SKIP");
    ptr->element = i;
    ptr->next = z[x[i]];
    z[x[i]] = ptr;
  }

  /* Searching */
  for (j = m - 1; j < n; j += m) {
    /* for (ptr = z[y[j]]; ptr != NULL; ptr = ptr->next) */
    for (ptr = z[trace_get(y, j)]; ptr != NULL; ptr = ptr->next) {
      /* if (memcmp(x, y + j - ptr->element, m) == 0) */
      if (ptr->element == 0) {
        if (x[0] == y[j] &&
            trace_memcmp(x + 1, y + j + 1, m - 1, j + 1) == 0) {
          OUTPUT(j);
        }
      } else {
        if (trace_memcmp(x, y + j - ptr->element, m, j - ptr->element) == 0) {
          OUTPUT(j - ptr->element);
        }
      }
    }
  }
}

List skip_search(char* pattern, int pattern_size, 
                 char* text, int text_size) {
  return string_matcher_array(SKIP, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(SKIP, argc, argv);
}
