#include <stdio.h>
#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node21.html#SECTION00210 */

void preBmBc(char *x, int m, int bmBc[]) {
  int i;
 
  for (i = 0; i < ASIZE; ++i)
    bmBc[i] = m;
  for (i = 0; i < m - 1; ++i)
    bmBc[x[i]] = m - i - 1;
}

void preQsBc(char *x, int m, int qsBc[]) {
  int i;

  for (i = 0; i < ASIZE; ++i)
    qsBc[i] = m + 1;
  for (i = 0; i < m; ++i)
    qsBc[x[i]] = m - i;
}

void SMITH(char *x, int m, char *y, int n) {
   int j, bmBc[ASIZE], qsBc[ASIZE];

   /* Preprocessing */
   preBmBc(x, m, bmBc);
   preQsBc(x, m, qsBc);

   /* Searching */
   j = 0;
   set_txt_length(n);
   while (j <= n - m) {
     start_pruning_duplicates();
     /* if (memcmp(x, y + j, m) == 0) */
     if (trace_memcmp(x, y + j, m, j) == 0)
         OUTPUT(j);
     /* j += MAX(bmBc[y[j + m - 1]], qsBc[y[j + m]]); */
     j += MAX( qsBc[trace_get(y, j + m)], bmBc[trace_get(y, j + m - 1)] );
     stop_pruning_duplicates();
   }
}

List smith(char* pattern, int pattern_size, 
           char* text, int text_size) {
  return string_matcher_array(SMITH, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(SMITH, argc, argv);
}
