#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/tunedbm.html#SECTION00195 */

void preBmBc(char *x, int m, int bmBc[]) {
  int i;
 
  for (i = 0; i < ASIZE; ++i)
    bmBc[i] = m;
  for (i = 0; i < m - 1; ++i)
    bmBc[x[i]] = m - i - 1;
}

void TUNEDBM(char *x, int m, char *y, int n) {
  int j, k, shift, bmBc[ASIZE];
 
  /* Preprocessing */
  preBmBc(x, m, bmBc);
  shift = bmBc[x[m - 1]];
  bmBc[x[m - 1]] = 0;
  memset(y + n, x[m - 1], m);
 
  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j < n) {
    start_pruning_duplicates();
    k = bmBc[trace_get(y, j + m -1)];
    while (k !=  0) {
      j += k; k = bmBc[trace_get(y, j + m -1)];
      j += k; k = bmBc[trace_get(y, j + m -1)];
      j += k; k = bmBc[trace_get(y, j + m -1)];
    }
    if (trace_memcmp(x, y + j, m - 1, j) == 0 && j < n)
      OUTPUT(j);
    j += shift;                          /* shift */
    stop_pruning_duplicates();

    /* k = bmBc[y[j + m -1]]; */
    /* while (k !=  0) { */
    /*   j += k; k = bmBc[y[j + m -1]]; */
    /*   j += k; k = bmBc[y[j + m -1]]; */
    /*   j += k; k = bmBc[y[j + m -1]]; */
    /* } */
    /* if (memcmp(x, y + j, m - 1) == 0 && j < n) */
    /*   OUTPUT(j); */
    /* j += shift;                          /\* shift *\/ */
  }
} 

List tuned_bm(char* pattern, int pattern_size, 
              char* text, int text_size) {
  return string_matcher_array(TUNEDBM, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(TUNEDBM, argc, argv);
}
