#include "utils.h"

/* http://igm.univ-mlv.fr/~lecroq/string/node20.html#SECTION00200 */

void suffixes(char *x, int m, int *suff) {
  int f, g, i;
 
  suff[m - 1] = m;
  g = m - 1;
  for (i = m - 2; i >= 0; --i) {
    if (i > g && suff[i + m - 1 - f] < i - g)
      suff[i] = suff[i + m - 1 - f];
    else {
      if (i < g)
        g = i;
      f = i;
      while (g >= 0 && x[g] == x[g + m - 1 - f])
        --g;
      suff[i] = f - g;
    }
  }
}
 
void preBmGs(char *x, int m, int bmGs[]) {
  int i, j, suff[XSIZE];
 
  suffixes(x, m, suff);
 
  for (i = 0; i < m; ++i)
    bmGs[i] = m;
  j = 0;
  for (i = m - 1; i >= 0; --i)
    if (suff[i] == i + 1)
      for (; j < m - 1 - i; ++j)
        if (bmGs[j] == m)
          bmGs[j] = m - 1 - i;
  for (i = 0; i <= m - 2; ++i)
    bmGs[m - 1 - suff[i]] = m - 1 - i;
} 

void preZtBc(char *x, int m, int ztBc[ASIZE][ASIZE]) {
  int i, j;

  for (i = 0; i < ASIZE; ++i)
    for (j = 0; j < ASIZE; ++j)
      ztBc[i][j] = m;
  for (i = 0; i < ASIZE; ++i)
    ztBc[i][x[0]] = m - 1;
  for (i = 1; i < m - 1; ++i)
    ztBc[x[i - 1]][x[i]] = m - 1 - i;
}


void ZT(char *x, int m, char *y, int n) {
  int i, j, ztBc[ASIZE][ASIZE], bmGs[XSIZE];

  /* Preprocessing */
  preZtBc(x, m, ztBc);
  preBmGs(x, m, bmGs);

  /* Searching */
  j = 0;
  set_txt_length(n);
  while (j <= n - m) {
    start_pruning_duplicates();
    i = m - 1;
    /* while (i < m && x[i] == y[i + j]) */
    while (i < m && i >= 0 && x[i] == trace_get(y, i + j))
      --i;
    if (i < 0) {
      OUTPUT(j);
      j += bmGs[0];
    }
    else
      j += MAX(bmGs[i],
               /* ztBc[y[j + m - 2]][y[j + m - 1]]); */
               ztBc[trace_get(y, j + m - 2)][trace_get(y, j + m - 1)]);
               /* ((i + m - 2 >= 0)  */
               /*  ? ztBc[trace_get(y, j + m - 2)][trace_get(y, j + m - 1)] */
               /*  : 0)); */
    stop_pruning_duplicates();
  }
} 

List zhu_takaoka(char* pattern, int pattern_size, 
                 char* text, int text_size) {
  return string_matcher_array(ZT, pattern, pattern_size, text, text_size);
}

int main(int argc, char* argv[]) {
  return string_matcher_main(ZT, argc, argv);
}
